local f = io.open("sowpods.dic", "rb")
local dic = f:read("*all")
f:close()

local function search(dic, str)
	local pos = 1
	local node = 1

	while node ~= 0 do
		local char = str:byte(pos) or 0
		local index = (node - 1) * 10
		local splitchar = dic:byte(index + 1)
		
		if char < splitchar then
			local b1, b2, b3 = dic:byte(index + 2, index + 4)
			node = b1 + b2 * 256 + b3 * 65536
		elseif char == splitchar then
			if char == 0 then
				return true
			end
			pos = pos + 1
			local b1, b2, b3 = dic:byte(index + 5, index + 7)
			node = b1 + b2 * 256 + b3 * 65536
		else
			local b1, b2, b3 = dic:byte(index + 8, index + 10)
			node = b1 + b2 * 256 + b3 * 65536
		end
	end
	return false
end


print(search(dic, "ZYMOSIMETER"))	--> should be true
print(search(dic, "GIDEROS"))		--> should be false
